module BurrowsWheeler
  class CircularSuffixArray
    extend Forwardable

    def initialize(string)
      suffixes = (0..string.length - 1).map do |shift|
        CircularString.new(string, shift)
      end.sort

      @indices = suffixes.map(&:shift)
    end

    def_delegators :@indices, :length, :[], :map, :each, :to_a
  end
end
